Index: /trunk/source/Lib/TLibEncoder/SEIwrite.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/SEIwrite.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/SEIwrite.cpp	(revision 1413)
@@ -846,20 +1076,44 @@
 }
 
-Void SEIWriter::xWriteSEIMasteringDisplayColourVolume(const SEIMasteringDisplayColourVolume& sei)
-{
-  WRITE_CODE( sei.values.primaries[0][0],  16,  "display_primaries_x[0]" );
-  WRITE_CODE( sei.values.primaries[0][1],  16,  "display_primaries_y[0]" );
-
-  WRITE_CODE( sei.values.primaries[1][0],  16,  "display_primaries_x[1]" );
-  WRITE_CODE( sei.values.primaries[1][1],  16,  "display_primaries_y[1]" );
-
-  WRITE_CODE( sei.values.primaries[2][0],  16,  "display_primaries_x[2]" );
-  WRITE_CODE( sei.values.primaries[2][1],  16,  "display_primaries_y[2]" );
-
-  WRITE_CODE( sei.values.whitePoint[0],    16,  "white_point_x" );
-  WRITE_CODE( sei.values.whitePoint[1],    16,  "white_point_y" );
-    
-  WRITE_CODE( sei.values.maxLuminance,     32,  "max_display_mastering_luminance" );
-  WRITE_CODE( sei.values.minLuminance,     32,  "min_display_mastering_luminance" );
+Void SEIWriter::xWriteSEIDeinterlaceFieldIdentification(const SEIDeinterlaceFieldIdentification& sei)
+{
+  WRITE_FLAG( sei.m_deinterlacedPictureSourceParityFlag, "deinterlaced_picture_source_parity_flag" );
+}
+
+
+Void SEIWriter::xWriteSEIContentLightLevelInfo(const SEIContentLightLevelInfo& sei)
+{
+  WRITE_CODE( sei.m_maxContentLightLevel,    16, "max_content_light_level"     );
+  WRITE_CODE( sei.m_maxPicAverageLightLevel, 16, "max_pic_average_light_level" );
+}
+
+
+Void SEIWriter::xWriteSEIDependentRAPIndication(const SEIDependentRAPIndication& /*sei*/)
+{
+  // intentionally empty
+}
+
+
+Void SEIWriter::xWriteSEICodedRegionCompletion(const SEICodedRegionCompletion& sei)
+{
+  WRITE_UVLC( sei.m_nextSegmentAddress, "next_segment_address" );
+  if (sei.m_nextSegmentAddress)
+  {
+    WRITE_FLAG( sei.m_independentSliceSegmentFlag, "independent_slice_segment_flag" );
+  }
+}
+
+
+Void SEIWriter::xWriteSEIAlternativeTransferCharacteristics(const SEIAlternativeTransferCharacteristics& sei)
+{
+  WRITE_CODE(sei.m_preferredTransferCharacteristics, 8, "preferred_transfer_characteristics");
+}
+
+
+Void SEIWriter::xWriteSEIAmbientViewingEnvironment(const SEIAmbientViewingEnvironment& sei)
+{
+  WRITE_CODE(sei.m_ambientIlluminance, 32, "ambient_illuminance" );
+  WRITE_CODE(sei.m_ambientLightX,      16, "ambient_light_x" );
+  WRITE_CODE(sei.m_ambientLightY,      16, "ambient_light_y" );
 }
 
@@ -876,11 +1130,4 @@
   }
 }
-
-#if U0033_ALTERNATIVE_TRANSFER_CHARACTERISTICS_SEI
-Void SEIWriter::xWriteSEIAlternativeTransferCharacteristics(const SEIAlternativeTransferCharacteristics& sei)
-{
-  WRITE_CODE(sei.m_preferredTransferCharacteristics, 8, "preferred_transfer_characteristics");
-}
-#endif
 
 #if NH_MV
Index: /trunk/source/Lib/TLibEncoder/SEIwrite.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/SEIwrite.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/SEIwrite.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -53,30 +53,42 @@
 
 protected:
-  Void xWriteSEIuserDataUnregistered(const SEIuserDataUnregistered &sei);
-  Void xWriteSEIActiveParameterSets(const SEIActiveParameterSets& sei);
-  Void xWriteSEIDecodingUnitInfo(const SEIDecodingUnitInfo& sei, const TComSPS *sps);
-  Void xWriteSEIDecodedPictureHash(const SEIDecodedPictureHash& sei);
-  Void xWriteSEIBufferingPeriod(const SEIBufferingPeriod& sei, const TComSPS *sps);
-  Void xWriteSEIPictureTiming(const SEIPictureTiming& sei, const TComSPS *sps);
-  Void xWriteSEIRecoveryPoint(const SEIRecoveryPoint& sei);
-  Void xWriteSEIFramePacking(const SEIFramePacking& sei);
-  Void xWriteSEISegmentedRectFramePacking(const SEISegmentedRectFramePacking& sei);
-  Void xWriteSEIDisplayOrientation(const SEIDisplayOrientation &sei);
-  Void xWriteSEITemporalLevel0Index(const SEITemporalLevel0Index &sei);
-  Void xWriteSEIGradualDecodingRefreshInfo(const SEIGradualDecodingRefreshInfo &sei);
-  Void xWriteSEINoDisplay(const SEINoDisplay &sei);
-  Void xWriteSEIToneMappingInfo(const SEIToneMappingInfo& sei);
-  Void xWriteSEISOPDescription(const SEISOPDescription& sei);
-  Void xWriteSEIScalableNesting(TComBitIf& bs, const SEIScalableNesting& sei, const TComSPS *sps);
-  Void xWriteSEITempMotionConstrainedTileSets(const SEITempMotionConstrainedTileSets& sei);
-  Void xWriteSEITimeCode(const SEITimeCode& sei);
-  Void xWriteSEIChromaResamplingFilterHint(const SEIChromaResamplingFilterHint& sei);
-  Void xWriteSEIKneeFunctionInfo(const SEIKneeFunctionInfo &sei);
-  Void xWriteSEIColourRemappingInfo(const SEIColourRemappingInfo& sei);
-  Void xWriteSEIMasteringDisplayColourVolume( const SEIMasteringDisplayColourVolume& sei);
-#if U0033_ALTERNATIVE_TRANSFER_CHARACTERISTICS_SEI
+  Void xWriteSEIBufferingPeriod                   (const SEIBufferingPeriod& sei, const TComSPS *sps);
+  Void xWriteSEIPictureTiming                     (const SEIPictureTiming& sei, const TComSPS *sps);
+  Void xWriteSEIPanScanRect                       (const SEIPanScanRect& sei);
+  Void xWriteSEIFillerPayload                     (const SEIFillerPayload& sei);
+  Void xWriteSEIUserDataRegistered                (const SEIUserDataRegistered& sei);
+  Void xWriteSEIUserDataUnregistered              (const SEIUserDataUnregistered &sei);
+  Void xWriteSEIRecoveryPoint                     (const SEIRecoveryPoint& sei);
+  Void xWriteSEISceneInfo                         (const SEISceneInfo& sei);
+  Void xWriteSEIPictureSnapshot                   (const SEIPictureSnapshot& sei);
+  Void xWriteSEIProgressiveRefinementSegmentStart (const SEIProgressiveRefinementSegmentStart& sei);
+  Void xWriteSEIProgressiveRefinementSegmentEnd   (const SEIProgressiveRefinementSegmentEnd& sei);
+  Void xWriteSEIFilmGrainCharacteristics          (const SEIFilmGrainCharacteristics& sei);
+  Void xWriteSEIPostFilterHint                    (const SEIPostFilterHint& sei, const TComSPS *sps);
+  Void xWriteSEIToneMappingInfo                   (const SEIToneMappingInfo& sei);
+  Void xWriteSEIFramePacking                      (const SEIFramePacking& sei);
+  Void xWriteSEIDisplayOrientation                (const SEIDisplayOrientation &sei);
+  Void xWriteSEIGreenMetadataInfo                 (const SEIGreenMetadataInfo &sei);
+  Void xWriteSEISOPDescription                    (const SEISOPDescription& sei);
+  Void xWriteSEIActiveParameterSets               (const SEIActiveParameterSets& sei);
+  Void xWriteSEIDecodingUnitInfo                  (const SEIDecodingUnitInfo& sei, const TComSPS *sps);
+  Void xWriteSEITemporalLevel0Index               (const SEITemporalLevel0Index &sei);
+  Void xWriteSEIDecodedPictureHash                (const SEIDecodedPictureHash& sei);
+  Void xWriteSEIScalableNesting                   (TComBitIf& bs, const SEIScalableNesting& sei, const TComSPS *sps);
+  Void xWriteSEIRegionRefreshInfo                 (const SEIRegionRefreshInfo &sei);
+  Void xWriteSEINoDisplay                         (const SEINoDisplay &sei);
+  Void xWriteSEITimeCode                          (const SEITimeCode& sei);
+  Void xWriteSEIMasteringDisplayColourVolume      (const SEIMasteringDisplayColourVolume& sei);
+  Void xWriteSEISegmentedRectFramePacking         (const SEISegmentedRectFramePacking& sei);
+  Void xWriteSEITempMotionConstrainedTileSets     (const SEITempMotionConstrainedTileSets& sei);
+  Void xWriteSEIChromaResamplingFilterHint        (const SEIChromaResamplingFilterHint& sei);
+  Void xWriteSEIKneeFunctionInfo                  (const SEIKneeFunctionInfo &sei);
+  Void xWriteSEIColourRemappingInfo               (const SEIColourRemappingInfo& sei);
+  Void xWriteSEIDeinterlaceFieldIdentification    (const SEIDeinterlaceFieldIdentification& sei);
+  Void xWriteSEIContentLightLevelInfo             (const SEIContentLightLevelInfo& sei);
+  Void xWriteSEIDependentRAPIndication            (const SEIDependentRAPIndication& sei);
+  Void xWriteSEICodedRegionCompletion             (const SEICodedRegionCompletion& sei);
   Void xWriteSEIAlternativeTransferCharacteristics(const SEIAlternativeTransferCharacteristics& sei);
-#endif
-
+  Void xWriteSEIAmbientViewingEnvironment         (const SEIAmbientViewingEnvironment& sei);
 #if NH_MV
   Void xWriteSEILayersNotPresent              ( const SEILayersNotPresent& sei);
Index: /trunk/source/Lib/TLibEncoder/SyntaxElementWriter.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/SyntaxElementWriter.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/SyntaxElementWriter.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/SyntaxElementWriter.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/SyntaxElementWriter.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/SyntaxElementWriter.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/TEncAnalyze.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -49,4 +49,7 @@
 #include "TLibCommon/TComChromaFormat.h"
 #include "math.h"
+#if EXTENSION_360_VIDEO
+#include "TAppEncHelper360/TExt360EncAnalyze.h"
+#endif
 
 //! \ingroup TLibEncoder
@@ -66,4 +69,11 @@
   Double    m_dFrmRate; //--CFG_KDY
   Double    m_MSEyuvframe[MAX_NUM_COMPONENT]; // sum of MSEs
+#if JVET_F0064_MSSSIM
+  Double    m_MSSSIM[MAX_NUM_COMPONENT];
+#endif
+
+#if EXTENSION_360_VIDEO
+  TExt360EncAnalyze m_ext360;
+#endif
 
 public:
@@ -71,6 +81,9 @@
   TEncAnalyze() { clear(); }
 
-  Void  addResult( Double psnr[MAX_NUM_COMPONENT], Double bits, const Double MSEyuvframe[MAX_NUM_COMPONENT])
-  {
+#if JVET_F0064_MSSSIM
+  Void  addResult( Double psnr[MAX_NUM_COMPONENT], Double bits, const Double MSEyuvframe[MAX_NUM_COMPONENT], const Double MSSSIM[MAX_NUM_COMPONENT] )  {
+#else
+  Void  addResult( Double psnr[MAX_NUM_COMPONENT], Double bits, const Double MSEyuvframe[MAX_NUM_COMPONENT] )  {
+#endif
     m_dAddBits  += bits;
     for(UInt i=0; i<MAX_NUM_COMPONENT; i++)
@@ -78,4 +91,7 @@
       m_dPSNRSum[i] += psnr[i];
       m_MSEyuvframe[i] += MSEyuvframe[i];
+#if JVET_F0064_MSSSIM
+      m_MSSSIM[i] += MSSSIM[i];
+#endif
     }
 
@@ -84,7 +100,13 @@
 
   Double  getPsnr(ComponentID compID) const { return  m_dPSNRSum[compID];  }
+#if JVET_F0064_MSSSIM
+  Double  getMsssim(ComponentID compID) const { return  m_MSSSIM[compID];  }
+#endif
   Double  getBits()                   const { return  m_dAddBits;   }
   Void    setBits(Double numBits)     { m_dAddBits=numBits; }
   UInt    getNumPic()                 const { return  m_uiNumPic;   }
+#if EXTENSION_360_VIDEO
+  TExt360EncAnalyze& getExt360Info() { return m_ext360; }
+#endif
 
   Void    setFrmRate  (Double dFrameRate) { m_dFrmRate = dFrameRate; } //--CFG_KDY
@@ -96,6 +118,12 @@
       m_dPSNRSum[i] = 0;
       m_MSEyuvframe[i] = 0;
+#if JVET_F0064_MSSSIM
+      m_MSSSIM[i] = 0;
+#endif
     }
     m_uiNumPic = 0;
+#if EXTENSION_360_VIDEO
+    m_ext360.clear();
+#endif
   }
 
@@ -137,5 +165,9 @@
 
 
+#if JVET_F0064_MSSSIM
+  Void    printOut ( TChar cDelim, const ChromaFormat chFmt, const Bool printMSEBasedSNR, const Bool printSequenceMSE, const Bool printMSSSIM, const BitDepths &bitDepths )
+#else
   Void    printOut ( TChar cDelim, const ChromaFormat chFmt, const Bool printMSEBasedSNR, const Bool printSequenceMSE, const BitDepths &bitDepths )
+#endif
   {
     Double dFps     =   m_dFrmRate; //--CFG_KDY
@@ -171,4 +203,10 @@
           printf( "         \tTotal Frames |   "   "Bitrate     "  "Y-PSNR" );
 
+#if JVET_F0064_MSSSIM
+          if (printMSSSIM)
+          {
+            printf( "    Y-MS-SSIM");
+          }
+#endif
           if (printSequenceMSE)
           {
@@ -186,4 +224,11 @@
                  getPsnr(COMPONENT_Y) / (Double)getNumPic() );
 
+#if JVET_F0064_MSSSIM
+          if (printMSSSIM)
+          {
+            printf("    %8.6lf", getMsssim(COMPONENT_Y) / (Double)getNumPic());
+          }
+#endif
+
           if (printSequenceMSE)
           {
@@ -203,4 +248,11 @@
         {
           printf( "\tTotal Frames |   "   "Bitrate     "  "Y-PSNR" );
+
+#if JVET_F0064_MSSSIM
+          if (printMSSSIM)
+          {
+            printf( "Y-MS-SSIM");
+          }
+#endif
 
           if (printSequenceMSE)
@@ -219,4 +271,10 @@
                  getPsnr(COMPONENT_Y) / (Double)getNumPic() );
 
+#if JVET_F0064_MSSSIM
+          if (printMSSSIM)
+          {
+            printf("%8.6lf", getMsssim(COMPONENT_Y) / (Double)getNumPic());
+          }
+#endif
           if (printSequenceMSE)
           {
@@ -242,4 +300,10 @@
             printf( "         \tTotal Frames |   "   "Bitrate     "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR    "  "YUV-PSNR " );
 
+#if JVET_F0064_MSSSIM
+            if (printMSSSIM)
+            {
+              printf("   Y-MS-SSIM    " "U-MS-SSIM    " "V-MS-SSIM ");
+            }
+#endif
             if (printSequenceMSE)
             {
@@ -260,4 +324,13 @@
                    PSNRyuv );
 
+#if JVET_F0064_MSSSIM
+            if (printMSSSIM)
+            {
+              printf("    %8.6lf     " "%8.6lf     " "%8.6lf ",
+                     getMsssim(COMPONENT_Y) / (Double)getNumPic(),
+                     getMsssim(COMPONENT_Cb) / (Double)getNumPic(),
+                     getMsssim(COMPONENT_Cr) / (Double)getNumPic());
+            }
+#endif
             if (printSequenceMSE)
             {
@@ -285,4 +358,15 @@
             printf( "\tTotal Frames |   "   "Bitrate     "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR    "  "YUV-PSNR " );
             
+#if JVET_F0064_MSSSIM
+            if (printMSSSIM)
+            {
+              printf("   Y-MS-SSIM    " "U-MS-SSIM    " "V-MS-SSIM ");
+            }
+#endif
+
+#if EXTENSION_360_VIDEO
+            m_ext360.printHeader();
+#endif
+
             if (printSequenceMSE)
             {
@@ -303,4 +387,18 @@
                    PSNRyuv );
 
+#if JVET_F0064_MSSSIM
+            if (printMSSSIM)
+            {
+              printf("    %8.6lf     " "%8.6lf     " "%8.6lf ",
+                     getMsssim(COMPONENT_Y) / (Double)getNumPic(),
+                     getMsssim(COMPONENT_Cb) / (Double)getNumPic(),
+                     getMsssim(COMPONENT_Cr) / (Double)getNumPic());
+            }
+#endif
+
+#if EXTENSION_360_VIDEO
+            m_ext360.printPSNRs(getNumPic());
+#endif
+
             if (printSequenceMSE)
             {
Index: /trunk/source/Lib/TLibEncoder/TEncBinCoder.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncBinCoder.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncBinCoder.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/TEncBinCoderCABAC.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncBinCoderCABAC.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncBinCoderCABAC.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/TEncBinCoderCABAC.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncBinCoderCABAC.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncBinCoderCABAC.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncBinCoderCABACCounter.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -184,5 +184,5 @@
   WRITE_FLAG( pcPPS->getOutputFlagPresentFlag() ? 1 : 0,     "output_flag_present_flag" );
   WRITE_CODE( pcPPS->getNumExtraSliceHeaderBits(), 3,        "num_extra_slice_header_bits");
-  WRITE_FLAG( pcPPS->getSignHideFlag(), "sign_data_hiding_flag" );
+  WRITE_FLAG( pcPPS->getSignDataHidingEnabledFlag(),         "sign_data_hiding_enabled_flag" );
   WRITE_FLAG( pcPPS->getCabacInitPresentFlag() ? 1 : 0,   "cabac_init_present_flag" );
 #if H_3D_PPS_FIX_DEPTH
@@ -216,5 +216,5 @@
   WRITE_FLAG( pcPPS->getUseWP() ? 1 : 0,  "weighted_pred_flag" );   // Use of Weighting Prediction (P_SLICE)
   WRITE_FLAG( pcPPS->getWPBiPred() ? 1 : 0, "weighted_bipred_flag" );  // Use of Weighting Bi-Prediction (B_SLICE)
-  WRITE_FLAG( pcPPS->getTransquantBypassEnableFlag() ? 1 : 0, "transquant_bypass_enable_flag" );
+  WRITE_FLAG( pcPPS->getTransquantBypassEnabledFlag()  ? 1 : 0, "transquant_bypass_enabled_flag" );
   WRITE_FLAG( pcPPS->getTilesEnabledFlag()             ? 1 : 0, "tiles_enabled_flag" );
   WRITE_FLAG( pcPPS->getEntropyCodingSyncEnabledFlag() ? 1 : 0, "entropy_coding_sync_enabled_flag" );
@@ -235,9 +235,7 @@
       }
     }
-    if(pcPPS->getNumTileColumnsMinus1() !=0 || pcPPS->getNumTileRowsMinus1() !=0)
-    {
+    assert ((pcPPS->getNumTileColumnsMinus1() + pcPPS->getNumTileRowsMinus1()) != 0);
       WRITE_FLAG( pcPPS->getLoopFilterAcrossTilesEnabledFlag()?1 : 0,          "loop_filter_across_tiles_enabled_flag");
     }
-  }
   WRITE_FLAG( pcPPS->getLoopFilterAcrossSlicesEnabledFlag()?1 : 0,        "pps_loop_filter_across_slices_enabled_flag");
   WRITE_FLAG( pcPPS->getDeblockingFilterControlPresentFlag()?1 : 0,       "deblocking_filter_control_present_flag");
@@ -245,6 +243,6 @@
   {
     WRITE_FLAG( pcPPS->getDeblockingFilterOverrideEnabledFlag() ? 1 : 0,  "deblocking_filter_override_enabled_flag" );
-    WRITE_FLAG( pcPPS->getPicDisableDeblockingFilterFlag() ? 1 : 0,       "pps_disable_deblocking_filter_flag" );
-    if(!pcPPS->getPicDisableDeblockingFilterFlag())
+    WRITE_FLAG( pcPPS->getPPSDeblockingFilterDisabledFlag() ? 1 : 0,      "pps_deblocking_filter_disabled_flag" );
+    if(!pcPPS->getPPSDeblockingFilterDisabledFlag())
     {
       WRITE_SVLC( pcPPS->getDeblockingFilterBetaOffsetDiv2(),             "pps_beta_offset_div2" );
@@ -392,5 +390,4 @@
 Void  TEncCavlc::codePps3dExtension        ( const TComPPS* pcPPS )
 {
-#if NH_3D_DLT
   WRITE_FLAG( pcPPS->getDLT()->getDltPresentFlag() ? 1 : 0, "dlts_present_flag" );
 
@@ -510,5 +507,4 @@
     }
   }
-#endif
 }
 #endif
@@ -849,7 +845,7 @@
     }
   }
-  WRITE_FLAG( pcSPS->getTMVPFlagsPresent()  ? 1 : 0,           "sps_temporal_mvp_enable_flag" );
-
-  WRITE_FLAG( pcSPS->getUseStrongIntraSmoothing(),             "sps_strong_intra_smoothing_enable_flag" );
+  WRITE_FLAG( pcSPS->getSPSTemporalMVPEnabledFlag()  ? 1 : 0,  "sps_temporal_mvp_enabled_flag" );
+
+  WRITE_FLAG( pcSPS->getUseStrongIntraSmoothing(),             "strong_intra_smoothing_enable_flag" );
 
   WRITE_FLAG( pcSPS->getVuiParametersPresentFlag(),             "vui_parameters_present_flag" );
@@ -1428,9 +1424,5 @@
     for( Int j = 0; j  <=  vps->getMaxSubLayersInLayerSetMinus1( currLsIdx ); j++ )
     {  
-#if NH_3D_FIX_TICKET_114
       if( j > 0  &&  dpbSize->getSubLayerFlagInfoPresentFlag( i )  )  
-#else
-      if( j > 0  &&  dpbSize->getSubLayerDpbInfoPresentFlag( i, j )  )  
-#endif
       {
         WRITE_FLAG( dpbSize->getSubLayerDpbInfoPresentFlag( i, j ) ? 1 : 0 , "sub_layer_dpb_info_present_flag" );
@@ -1982,5 +1974,5 @@
         }
       }
-      if (pcSlice->getSPS()->getTMVPFlagsPresent())
+      if (pcSlice->getSPS()->getSPSTemporalMVPEnabledFlag())
       {
 #if NH_MV
@@ -2166,5 +2158,5 @@
       xCodePredWeightTable( pcSlice );
     }
-#if NH_3D_IC
+#if NH_3D
     else if( pcSlice->getViewIndex() && ( pcSlice->getSliceType() == P_SLICE || pcSlice->getSliceType() == B_SLICE )
       && !pcSlice->getIsDepth() && vps->getNumRefListLayers( layerId ) > 0 
@@ -2178,6 +2170,4 @@
       }
     }
-#endif
-#if NH_3D_IV_MERGE
     assert(pcSlice->getMaxNumMergeCand()<=MRG_MAX_NUM_CANDS_MEM);
 #else
@@ -2186,5 +2176,5 @@
     if (!pcSlice->isIntra())
     {
-#if NH_3D_IV_MERGE
+#if NH_3D
       WRITE_UVLC( ( ( pcSlice->getMpiFlag( ) || pcSlice->getIvMvPredFlag( ) || pcSlice->getViewSynthesisPredFlag( ) ) ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
 #else
@@ -2220,5 +2210,5 @@
       if (pcSlice->getDeblockingFilterOverrideFlag())
       {
-        WRITE_FLAG(pcSlice->getDeblockingFilterDisable(), "slice_disable_deblocking_filter_flag");
+        WRITE_FLAG(pcSlice->getDeblockingFilterDisable(), "slice_deblocking_filter_disabled_flag");
         if(!pcSlice->getDeblockingFilterDisable())
         {
@@ -2428,13 +2418,13 @@
   if( ptl->getV2ConstraintsPresentFlag() ) 
   {
-    WRITE_FLAG( ptl->getMax12bitConstraintFlag( ) ? 1 : 0 , "max_12bit_constraint_flag" );
-    WRITE_FLAG( ptl->getMax10bitConstraintFlag( ) ? 1 : 0 , "max_10bit_constraint_flag" );
-    WRITE_FLAG( ptl->getMax8bitConstraintFlag( ) ? 1 : 0 , "max_8bit_constraint_flag" );
-    WRITE_FLAG( ptl->getMax422chromaConstraintFlag( ) ? 1 : 0 , "max_422chroma_constraint_flag" );
-    WRITE_FLAG( ptl->getMax420chromaConstraintFlag( ) ? 1 : 0 , "max_420chroma_constraint_flag" );
-    WRITE_FLAG( ptl->getMaxMonochromeConstraintFlag( ) ? 1 : 0 , "max_monochrome_constraint_flag" );
-    WRITE_FLAG( ptl->getIntraConstraintFlag( ) ? 1 : 0 , "intra_constraint_flag" );
-    WRITE_FLAG( ptl->getOnePictureOnlyConstraintFlag( ) ? 1 : 0 , "one_picture_only_constraint_flag" );
-    WRITE_FLAG( ptl->getLowerBitRateConstraintFlag( ) ? 1 : 0 , "lower_bit_rate_constraint_flag" );
+    WRITE_FLAG( ptl->getMax12bitConstraintFlag       ( ) ? 1 : 0 , "max_12bit_constraint_flag" );
+    WRITE_FLAG( ptl->getMax10bitConstraintFlag       ( ) ? 1 : 0 , "max_10bit_constraint_flag" );
+    WRITE_FLAG( ptl->getMax8bitConstraintFlag        ( ) ? 1 : 0 , "max_8bit_constraint_flag" );
+    WRITE_FLAG( ptl->getMax422chromaConstraintFlag   ( ) ? 1 : 0 , "max_422chroma_constraint_flag" );
+    WRITE_FLAG( ptl->getMax420chromaConstraintFlag   ( ) ? 1 : 0 , "max_420chroma_constraint_flag" );
+    WRITE_FLAG( ptl->getMaxMonochromeConstraintFlag  ( ) ? 1 : 0 , "max_monochrome_constraint_flag" );
+    WRITE_FLAG( ptl->getIntraConstraintFlag          ( ) ? 1 : 0 , "intra_constraint_flag" );
+    WRITE_FLAG( ptl->getOnePictureOnlyConstraintFlag ( ) ? 1 : 0 , "one_picture_only_constraint_flag" );
+    WRITE_FLAG( ptl->getLowerBitRateConstraintFlag   ( ) ? 1 : 0 , "lower_bit_rate_constraint_flag" );
     WRITE_CODE( 0, 16, "XXX_reserved_zero_34bits[0..15]");
     WRITE_CODE( 0, 16, "XXX_reserved_zero_34bits[16..31]");
@@ -2473,4 +2463,12 @@
     WRITE_CODE(0 ,  2, PTL_TRACE_TEXT("reserved_zero_34bits[32..33]"    ));
   }
+  else if (ptl->getProfileIdc() == Profile::MAIN10)
+  {
+    WRITE_CODE(0x00   ,  7, PTL_TRACE_TEXT("reserved_zero_7bits"     ));
+    WRITE_FLAG(ptl->getOnePictureOnlyConstraintFlag(), PTL_TRACE_TEXT("one_picture_only_constraint_flag"));
+    WRITE_CODE(0x0000 , 16, PTL_TRACE_TEXT("reserved_zero_35bits[0..15]"     ));
+    WRITE_CODE(0x0000 , 16, PTL_TRACE_TEXT("reserved_zero_35bits[16..31]"    ));
+    WRITE_CODE(0x0    ,  3, PTL_TRACE_TEXT("reserved_zero_35bits[32..34]"    ));
+  }
   else
   {
@@ -2558,12 +2556,10 @@
 }
 
-#if NH_3D_ARP
+#if NH_3D
 Void TEncCavlc::codeARPW( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
   assert(0);
 }
-#endif
-
-#if NH_3D_IC
+
 Void TEncCavlc::codeICFlag( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
@@ -2586,5 +2582,5 @@
   assert(0);
 }
-#if NH_3D_DIS
+#if NH_3D
 Void TEncCavlc::codeDIS( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
@@ -2689,5 +2685,5 @@
 }
 
-Void TEncCavlc::estBit( estBitsSbacStruct* /*pcEstBitsCabac*/, Int /*width*/, Int /*height*/, ChannelType /*chType*/ )
+Void TEncCavlc::estBit( estBitsSbacStruct* /*pcEstBitsCabac*/, Int /*width*/, Int /*height*/, ChannelType /*chType*/, COEFF_SCAN_TYPE /*scanType*/ )
 {
   // printf("error : no VLC mode support in this version\n");
@@ -2867,12 +2863,10 @@
    assert(0);
  }
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
+#if NH_3D
 Void TEncCavlc::codeSDCFlag ( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
   assert(0);
 }
-#endif
-    
-#if NH_3D_DBBP
+
 Void TEncCavlc::codeDBBPFlag    ( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
Index: /trunk/source/Lib/TLibEncoder/TEncCavlc.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncCavlc.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncCavlc.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -130,23 +130,14 @@
   Void codeCUTransquantBypassFlag( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void codeSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx );
-#if NH_3D_DIS
+#if NH_3D
   Void codeDIS           ( TComDataCU* pcCU, UInt uiAbsPartIdx );
 #endif
   Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx );
-#if NH_3D_DMM || NH_3D_SDC_INTRA || NH_3D_SDC_INTER
-  Void  codeDeltaDC      ( TComDataCU* /*pcCU*/, UInt /*absPartIdx*/ ) { assert(0); };
-#endif
-#if NH_3D_ARP
+#if NH_3D
+  Void codeDeltaDC      ( TComDataCU* /*pcCU*/, UInt /*absPartIdx*/ ) { assert(0); };
   Void codeARPW          ( TComDataCU* pcCU, UInt uiAbsPartIdx );
-#endif
-#if NH_3D_IC
   Void codeICFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx );
-#endif
-
-#if NH_3D_SDC_INTRA || NH_3D_SDC_INTER
   Void codeSDCFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx );
-#endif
-#if NH_3D_DBBP
   Void codeDBBPFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx );
 #endif
@@ -179,5 +170,5 @@
   Void codeTransformSkipFlags ( TComTU &rTu, ComponentID component );
 
-  Void estBit            ( estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, ChannelType chType );
+  Void estBit            ( estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, ChannelType chType, COEFF_SCAN_TYPE scanType );
 
   Void xCodePredWeightTable          ( TComSlice* pcSlice );
